// Copyright 2010 Simon Massey. All rights reserved. net.sf.chex4j is licensed under the terms of the Eclipse Public License v1.0, as defined by the attached file LICENSE-ECLIPSE.txt.net.sf.chex4j is licensed under the terms of the Eclipse Public License v1.0, as defined by the attached file LICENSE-ECLIPSE.txt.
package net.sf.chex4j.internal;

public class Assert {
	
	final static boolean DONT_THROW_ERROR = checkSystemProperty();
	
	/**
	 * A call to this method is injected into instrumented classes to assert 
	 * the chex. 
	 *   
	 * @param b
	 * @param message
	 */
	static public void assertTrue(boolean b, String message) {
		if (!(b)) {
			if( DONT_THROW_ERROR ){
				StackTraceElement[] stackTraceElements = Thread.currentThread().getStackTrace();
				StackTraceElement above = stackTraceElements[2];
				System.err.println("chex4j constraint has failed ("+message+") at "+above.getClassName()+"."+above.getMethodName());
			} else {
				throw new java.lang.AssertionError(message);
			}
		}
	}

	public static boolean checkSystemProperty() {
		String throwError = System.getProperty(Assert.class.getCanonicalName()+".DONT_THROW_ERROR", "false");
		if( throwError.toLowerCase().equals("true")){
			return true;
		}
		return false;
	}
}
