// Copyright 2010 Simon Massey. All rights reserved. net.sf.chex4j is licensed under the terms of the Eclipse Public License v1.0, as defined by the attached file LICENSE-ECLIPSE.txt.net.sf.chex4j is licensed under the terms of the Eclipse Public License v1.0, as defined by the attached file LICENSE-ECLIPSE.txt.
package net.sf.chex4j.internal;

import java.util.ArrayList;
import java.util.List;

import net.sf.chex4j.Contract;

import javassist.CannotCompileException;
import javassist.CtClass;
import javassist.CtMethod;
import javassist.NotFoundException;

/*package*/ class InterfaceMethodsInstrumentor extends MethodsInstrumentorBase
		implements ClassInstrumentor {

	public boolean instrumentClass(CtClass ctClass)
			throws ClassNotFoundException, CannotCompileException,
			NotFoundException {
		return this.modifyInterfaceMethods(ctClass);
	}

	private boolean modifyInterfaceMethods(CtClass ctClass)
			throws NotFoundException, ClassNotFoundException,
			CannotCompileException {
		boolean workDone = false;
		CtClass[] ctInterfaces = ctClass.getInterfaces();
		for (CtClass ctInterface : ctInterfaces) {
			Object o = ctInterface.getAnnotation(Contract.class);
			if (o != null) {
				workDone |= modifyInterfaceMethods(ctClass, ctInterface);
			}
		}
		return workDone;
	}

	private boolean modifyInterfaceMethods(CtClass ctTarget, CtClass ctInterface)
			throws ClassNotFoundException, NotFoundException,
			CannotCompileException {
		List<MethodInstrumentionWork> work = new ArrayList<MethodInstrumentionWork>(
				ctInterface.getMethods().length);
		for (CtMethod m : ctInterface.getMethods()) {
			addWorkItem(ctTarget, work, m);
		}
		performInstrumentationWork(work);
		return !work.isEmpty();
	}

}
