// Copyright 2010 Simon Massey. All rights reserved. net.sf.chex4j is licensed under the terms of the Eclipse Public License v1.0, as defined by the attached file LICENSE-ECLIPSE.txt.net.sf.chex4j is licensed under the terms of the Eclipse Public License v1.0, as defined by the attached file LICENSE-ECLIPSE.txt.
package net.sf.chex4j.internal;

import java.io.IOException;

import javassist.CannotCompileException;
import javassist.NotFoundException;

public class OfflineClassTransformer extends AbstractClassTransformer {
	
	TransformedClassListener transformedClassListener = null;
	
	public OfflineClassTransformer(String outputDir, String classPoolClasspath) throws NotFoundException {
		classPool.appendPathList(classPoolClasspath);
		transformedClassListener = new TransformedClassWriteToDiskListener(outputDir);
	}

	@Override
	public byte[] transformClassfile(String canonicalName) throws NotFoundException,
			ClassNotFoundException, CannotCompileException, IOException {
		byte[] transformedClass = super.transformClassfile(canonicalName);
		if( null != transformedClass ) {
			transformedClassListener.onClassTransformed(canonicalName.replace('.', '/'), transformedClass);
		}
		return transformedClass;
	}
	
	public void loadClass(String className) throws NotFoundException, ClassNotFoundException, CannotCompileException, IOException {
		this.transformClassfile(className);
		classPool.get(className);
		return;
	}
}
